unit Main;

//     Delphi 6-7   Delphi 5
//     
//      :
//             http://www.cherepovets-city.ru/download/
//       RxLib (FreeWare).
//        :
//    - NameDir  TDirectoryEdit  TEdit
//    - RxLabel1  TRxLabel  TLabel
//    main.pas  main.dfm

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, FileCtrl, RxRichEd, ComCtrls, RXCtrls, Mask, ToolEdit,
  ExtCtrls;

type
  TForm1 = class(TForm)
    BnWork: TBitBtn;
    NameDir: TDirectoryEdit;
    RxLabel1: TRxLabel;
    ProgressBar1: TProgressBar;
    SbFile: TStatusBar;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    PanDelete: TPanel;
    Bevel1: TBevel;
    cbDelPrFile: TCheckBox;
    cbRez: TCheckBox;
    cbKonf: TCheckBox;
    cbTrans: TCheckBox;
    rgPodkatalog: TRadioGroup;
    Label1: TLabel;
    cbEXE: TCheckBox;
    Label2: TLabel;
    procedure BnWorkClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure rgPodkatalogClick(Sender: TObject);
    procedure cbDelPrFileClick(Sender: TObject);
    procedure TestIndik(Sender: TObject);
  private
    procedure ObrabDirFile(TekNameDir:string); {    }
  public
    ProgrRootDir : string;
    ProtokolFile : TextFile;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function PrSimv(Vx: String): string;
Const Mas : string = '              ';
Var Temp, Vyx, Preob : string;
    i, Kod, Good : integer;
begin
 Vyx := Vx;
 For i := 1 to Length(Vx) do begin
  If Vx[i] <> '#' then Continue;
  Temp := Copy(Vx,i+1,4);
  If Length(temp) <> 4 then Continue;
  Val(Temp, Kod, Good);
  if Kod = 8470                 {      }
   then Preob := ''
   else begin
    if  (Good <> 0) or (Kod < 1025) or (Kod > 1105) then Continue;
    Preob := Mas[Kod-1024];
   end;
  Good := i; Kod := 5;
  If Vx[i-1] = '''' then begin Dec(Good);  Inc(Kod)  end
                    else Preob := '''' + Preob;
  If Vx[i+5] = '''' then Inc(Kod) else Preob := Preob + '''';
  Delete(Vyx, Good, Kod);
  Insert(Preob, Vyx, Good);
  Result := Vyx;
  Exit
 end;
 Result := Vyx;
end;

function ConvStr(Isx: String): string;
Var Ptom, Itog : string;
begin  {       Char }
  Ptom := Isx;
  Itog := PrSimv(Ptom);
  while Itog <> Ptom do begin
     Ptom := Itog;
     Itog := PrSimv(Ptom);  end;
  Result := Ptom;
end;

procedure TForm1.ObrabDirFile(TekNameDir:string); {    }
Var SrchDirStr, PromFileName :String;
    sr: TSearchRec;
    FileAttrs: Integer;
 procedure MyDeleteFile( MyFileName: string);
 begin  {           }
   FileSetAttr(MyFileName, 0 );
   DeleteFile(MyFileName);
 end;
 procedure ObrabFile; {    }
  Var ItogFileName, FromStr, ToStr : string;
  FromF, ToF: Textfile;
 begin
   ItogFileName := TekNameDir + '\' + sr.Name;
   PromFileName := ChangeFileExt(ItogFileName, '.~DFM');
   SbFile.Panels.Items[0].Text := ItogFileName;
   Writeln(ProtokolFile,ItogFileName);
    AssignFile(FromF, ItogFileName);     //    
    FileMode := 0;                       //   Delphi
    Reset(FromF);
    Readln(FromF, FromStr);
    CloseFile(FromF);
    if Pos('object', FromStr) = 0 then Exit; //    

   if FileExists(PromFileName) then begin
       MyDeleteFile(PromFileName);
       Writeln(ProtokolFile, PromFileName, ' - ');
     end;
   RenameFile ( ItogFileName, PromFileName );
   Writeln(ProtokolFile, PromFileName, ' -   ');
    AssignFile(FromF, PromFileName);
    FileMode := 0;
    Reset(FromF);
    AssignFile(ToF, ItogFileName);
    Rewrite(ToF);
      while not Eof(FromF) do begin
        Readln(FromF, FromStr);
        ToStr := ConvStr(FromStr);
        Writeln(ToF, ToStr);
      end;
    CloseFile(FromF);
    CloseFile(ToF);
  end;  { ObrabFile }
 procedure DelDirFile (Rash: String); {       }
 begin
  SrchDirStr := TekNameDir + '\*.'+ Rash;
  if FindFirst(SrchDirStr, FileAttrs, sr) = 0 then
   begin
    MyDeleteFile(TekNameDir + '\' + sr.Name);
    Writeln(ProtokolFile, TekNameDir + '\' + sr.Name, ' - ');
     while FindNext(sr) = 0 do begin
      MyDeleteFile(TekNameDir + '\' + sr.Name);
      Writeln(ProtokolFile, TekNameDir + '\' + sr.Name, ' - ');
   end  end;
  FindClose(sr);
 end;
  {       
    , ..      
    }
 procedure DelZavFile (Rash, Zavis : String);
 begin
  SrchDirStr := TekNameDir + '\*.'+ Rash;
   if FindFirst(SrchDirStr, FileAttrs, sr) = 0 then
   begin
    PromFileName := TekNameDir + '\' + sr.Name;
    delete(PromFileName, length(PromFileName)-2, 3);
    PromFileName := PromFileName + Zavis;
    If FileExists(PromFileName) then begin
      MyDeleteFile(TekNameDir + '\' + sr.Name);
      Writeln(ProtokolFile, TekNameDir + '\' + sr.Name, ' - '); end;
     while FindNext(sr) = 0 do begin
      PromFileName := TekNameDir + '\' + sr.Name;
      delete(PromFileName, length(PromFileName)-2, 3);
      PromFileName := PromFileName + Zavis;
       If FileExists(PromFileName) then begin
        MyDeleteFile(TekNameDir + '\' + sr.Name);
        Writeln(ProtokolFile, TekNameDir + '\' + sr.Name, ' - ');
   end  end  end;
  FindClose(sr);
 end;
begin
  FileAttrs := faReadOnly + faArchive;
  SrchDirStr := TekNameDir + '\*.dfm';
  if FindFirst(SrchDirStr, FileAttrs, sr) = 0 then begin
   ObrabFile;
   while FindNext(sr) = 0 do ObrabFile;              end;
  FindClose(sr);
  If not cbDelPrFile.Checked then exit;
    {    }
  If cbEXE.Checked then DelDirFile('exe');
  If cbRez.Checked then begin DelDirFile('~dfm');    DelDirFile('~dsk');
                              DelDirFile('~pas');    DelDirFile('~dpr')  end;
  If cbKonf.Checked then begin
    DelZavFile('dsk','dpr');    DelZavFile('ddp','dfm');
    DelZavFile('dti','dfm');    DelZavFile('map','dpr');
    DelZavFile('drc','dpr');    DelZavFile('cfg','dpr');
    DelZavFile('dof','dpr')     end;
  If cbTrans.Checked then DelZavFile('dcu','pas')
end;

 {    .  ,
  ..          .
          
   ,   . }
procedure OB_REC (Path_s : string);
Var  FF: TSearchRec;  
 begin
  if FindFirst(Path_s + '\*.*', faDirectory+faReadOnly+faHidden+faSysFile, FF) = 0
    then repeat { !!!    !!! }
     if (( FF.Attr and faDirectory ) = faDirectory ) and (FF.Name <> '.') and
      (FF.Name <> '..') then OB_REC (Path_s + '\' + FF.Name);
    until (FindNext(FF) <> 0);
  FindClose(FF);
  Form1.ObrabDirFile(Path_s);
end;

procedure TForm1.BnWorkClick(Sender: TObject);
begin   {    }
 If ProgressBar1.Visible then Exit; {     }
 If NameDir.Text = '' Then Exit;
 if not DirectoryExists(NameDir.Text) then begin
   ShowMessage('     Delphi');
   Exit     end;
 ProgressBar1.Visible := True;
  AssignFile(ProtokolFile, ProgrRootDir);
  if FileExists(ProgrRootDir) then Append(ProtokolFile)
                              else Rewrite(ProtokolFile);
  Writeln(ProtokolFile,'   ', DateTimeToStr(Now ));

  if rgPodkatalog.ItemIndex = 0 then OB_REC(NameDir.Text)
                                else ObrabDirFile(NameDir.Text);

 ProgressBar1.Visible := False;
 SbFile.Panels.Items[0].Text := '';
  Writeln(ProtokolFile,'   ', DateTimeToStr(Now ));
  Writeln(ProtokolFile,' ');
 CloseFile(ProtokolFile);
 ShowMessage(' ');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ProgrRootDir := ParamStr(0);
  Delete( ProgrRootDir, Length (ProgrRootDir)-8,9);
  ProgrRootDir := ProgrRootDir + 'Protokol.txt';
end;

procedure TForm1.rgPodkatalogClick(Sender: TObject);
begin   {    }
  if rgPodkatalog.ItemIndex = 0
    then rgPodkatalog.Color := cl3DLight
    else rgPodkatalog.Color := clBtnFace;
end;

procedure TForm1.cbDelPrFileClick(Sender: TObject);
begin    {      }
    {     }
  If (cbDelPrFile.Checked) and (PanDelete.Color = cl3DLight) then Exit;
  If cbDelPrFile.Checked
   then PanDelete.Color := cl3DLight
   else begin PanDelete.Color := clBtnFace;  cbEXE.Checked := False   end;
  cbRez.Checked := cbDelPrFile.Checked;
  cbKonf.Checked := cbDelPrFile.Checked;
  cbTrans.Checked := cbDelPrFile.Checked;
end;

procedure TForm1.TestIndik(Sender: TObject);
begin  {      }
  if (Sender as TCheckBox).State <> cbChecked then Exit;
  PanDelete.Color := cl3DLight;
  cbDelPrFile.State := cbChecked;
end;

end.
